Index: admin/post.php
===================================================================
--- admin/post.php	(revision 776)
+++ admin/post.php	(revision 957)
@@ -66,4 +66,5 @@
 	$status_combo[$v] = (string) $k;
 }
+$img_status_pattern = '<img class="img_select_option" alt="%1$s" title="%1$s" src="images/%2$s" />';
 
 # Formaters combo
@@ -87,4 +88,6 @@
 unset($rs);
 
+# Validation flag
+$bad_dt = false;
 
 # Get entry informations
@@ -166,6 +169,17 @@
 		$post_dt = '';
 	} else {
-		$post_dt = strtotime($_POST['post_dt']);
-		$post_dt = date('Y-m-d H:i',$post_dt);
+		try
+		{
+			$post_dt = strtotime($_POST['post_dt']);
+			if ($post_dt == false || $post_dt == -1) {
+				$bad_dt = true;
+				throw new Exception(__('Invalid publication date'));
+			}
+			$post_dt = date('Y-m-d H:i',$post_dt);
+		}
+		catch (Exception $e)
+		{
+			$core->error->add($e->getMessage());
+		}
 	}
 	
@@ -189,5 +203,5 @@
 
 # Create or update post
-if (!empty($_POST) && !empty($_POST['save']) && $can_edit_post)
+if (!empty($_POST) && !empty($_POST['save']) && $can_edit_post && !$bad_dt)
 {
 	$cur = $core->con->openCursor($core->prefix.'post');
@@ -293,19 +307,19 @@
 
 if (!empty($_GET['upd'])) {
-		echo '<p class="message">'.__('Entry has been successfully updated.').'</p>';
+	dcPage::message(__('Entry has been successfully updated.'));
 }
 elseif (!empty($_GET['crea'])) {
-		echo '<p class="message">'.__('Entry has been successfully created.').'</p>';
+	dcPage::message(__('Entry has been successfully created.'));
 }
 elseif (!empty($_GET['attached'])) {
-	echo '<p class="message">'.__('File has been successfully attached.').'</p>';
+	dcPage::message(__('File has been successfully attached.'));
 }
 elseif (!empty($_GET['rmattach'])) {
-	echo '<p class="message">'.__('Attachment has been successfully removed.').'</p>';
+	dcPage::message(__('Attachment has been successfully removed.'));
 }
 
 if (!empty($_GET['creaco'])) {
-		echo '<p class="message">'.__('Comment has been successfully created.').'</p>';
-	}
+	dcPage::message(__('Comment has been successfully created.'));
+}
 
 # XHTML conversion
@@ -314,15 +328,29 @@
 	$post_excerpt = $post_excerpt_xhtml;
 	$post_content = $post_content_xhtml;
-	$post_title = $post_title_xhtml;
 	$post_format = 'xhtml';
 	
-	echo '<p class="message">'.__('Don\'t forget to validate your XHTML conversion by saving your post.').'</p>';
+	dcPage::message(__('Don\'t forget to validate your XHTML conversion by saving your post.'));
 }
 
 echo '<h2>'.html::escapeHTML($core->blog->name).' &rsaquo; '.'<a href="posts.php">'.__('Entries').'</a> &rsaquo; <span class="page-title">'.$page_title;
-
-	if ($post_id) {
-		echo ' &ldquo;'.$post_title.'&rdquo;';
-	}
+if ($post_id) {
+	switch ($post_status) {
+		case 1:
+			$img_status = sprintf($img_status_pattern,__('published'),'check-on.png');
+			break;
+		case 0:
+			$img_status = sprintf($img_status_pattern,__('unpublished'),'check-off.png');
+			break;
+		case -1:
+			$img_status = sprintf($img_status_pattern,__('scheduled'),'scheduled.png');
+			break;
+		case -2:
+			$img_status = sprintf($img_status_pattern,__('pending'),'check-wrn.png');
+			break;
+		default:
+			$img_status = '';
+	}
+	echo ' &ldquo;'.$post_title.'&rdquo;'.' '.$img_status;
+}
 echo	'</span></h2>';
 
@@ -412,5 +440,5 @@
 	
 	'<p><label for="post_dt">'.__('Published on:').
-	form::field('post_dt',16,16,$post_dt).
+	form::field('post_dt',16,16,$post_dt,($bad_dt ? 'invalid' : '')).
 	'</label></p>'.
 	
@@ -423,6 +451,18 @@
 	'<p><label for="post_open_comment" class="classic">'.form::checkbox('post_open_comment',1,$post_open_comment).' '.
 	__('Accept comments').'</label></p>'.
+	($core->blog->settings->system->allow_comments ? 
+		(isContributionAllowed($post_id,strtotime($post_dt),true) ? 
+			'' :
+			'<p class="form-note warn">'.__('Warning: Comments are not more accepted for this entry.').'</p>') : 
+		'<p class="form-note warn">'.__('Warning: Comments are not accepted on this blog.').'</p>').
+
 	'<p><label for="post_open_tb" class="classic">'.form::checkbox('post_open_tb',1,$post_open_tb).' '.
 	__('Accept trackbacks').'</label></p>'.
+	($core->blog->settings->system->allow_trackbacks ? 
+		(isContributionAllowed($post_id,strtotime($post_dt),false) ? 
+			'' :
+			'<p class="form-note warn">'.__('Warning: Trackbacks are not more accepted for this entry.').'</p>') : 
+		'<p class="form-note warn">'.__('Warning: Trackbacks are not accepted on this blog.').'</p>').
+
 	'<p><label for="post_selected" class="classic">'.form::checkbox('post_selected',1,$post_selected).' '.
 	__('Selected entry').'</label></p>'.
@@ -568,4 +608,25 @@
 }
 
+# Controls comments or trakbacks capabilities
+function isContributionAllowed($id,$dt,$com=true)
+{
+	global $core;
+
+	if (!$id) {
+		return true;
+	}
+	if ($com) {
+		if (($core->blog->settings->system->comments_ttl == 0) || 
+			(time() - $core->blog->settings->system->comments_ttl*86400 < $dt)) {
+			return true;
+		}
+	} else {
+		if (($core->blog->settings->system->trackbacks_ttl == 0) || 
+			(time() - $core->blog->settings->system->trackbacks_ttl*86400 < $dt)) {
+			return true;
+		}
+	}
+	return false;
+}
 
 # Show comments or trackbacks
Index: admin/preferences.php
===================================================================
--- admin/preferences.php	(revision 821)
+++ admin/preferences.php	(revision 907)
@@ -162,6 +162,6 @@
 		$cur->user_options = new ArrayObject($user_options);
 		
-		# --BEHAVIOR-- adminBeforeUserUpdate
-		$core->callBehavior('adminBeforeUserUpdate',$cur,$core->auth->userID());
+		# --BEHAVIOR-- adminBeforeUserOptionsUpdate
+		$core->callBehavior('adminBeforeUserOptionsUpdate',$cur,$core->auth->userID());
 		
 		# Update user prefs
@@ -181,6 +181,6 @@
 		$core->updUser($core->auth->userID(),$cur);
 		
-		# --BEHAVIOR-- adminAfterUserUpdate
-		$core->callBehavior('adminAfterUserUpdate',$cur,$core->auth->userID());
+		# --BEHAVIOR-- adminAfterUserOptionsUpdate
+		$core->callBehavior('adminAfterUserOptionsUpdate',$cur,$core->auth->userID());
 		
 		http::redirect('preferences.php?updated=1');
@@ -343,5 +343,5 @@
 	dcPage::jsLoad('js/_preferences.js').
 	($user_acc_nodragdrop ? '' : dcPage::jsLoad('js/_preferences-dragdrop.js')).
-	dcPage::jsLoad('js/jquery/jquery-ui-1.8.12.custom.min.js').
+	dcPage::jsLoad('js/jquery/jquery-ui.custom.js').
 	dcPage::jsPageTabs($default_tab).
 	dcPage::jsConfirmClose('user-form').
@@ -352,20 +352,20 @@
 
 if (!empty($_GET['upd'])) {
-		echo '<p class="message">'.__('Personal information has been successfully updated.').'</p>';
+	dcPage::message(__('Personal information has been successfully updated.'));
 }
 if (!empty($_GET['updated'])) {
-		echo '<p class="message">'.__('Personal options has been successfully updated.').'</p>';
+	dcPage::message(__('Personal options has been successfully updated.'));
 }
 if (!empty($_GET['append'])) {
-		echo '<p class="message">'.__('Favorites have been successfully added.').'</p>';
+	dcPage::message(__('Favorites have been successfully added.'));
 }
 if (!empty($_GET['neworder'])) {
-	echo '<p class="message">'.__('Favorites have been successfully updated.').'</p>';
+	dcPage::message(__('Favorites have been successfully updated.'));
 }
 if (!empty($_GET['removed'])) {
-		echo '<p class="message">'.__('Favorites have been successfully removed.').'</p>';
+	dcPage::message(__('Favorites have been successfully removed.'));
 }
 if (!empty($_GET['replaced'])) {
-		echo '<p class="message">'.__('Default favorites have been successfully updated.').'</p>';
+	dcPage::message(__('Default favorites have been successfully updated.'));
 }
 
Index: admin/trackbacks.php
===================================================================
--- admin/trackbacks.php	(revision 510)
+++ admin/trackbacks.php	(revision 907)
@@ -92,5 +92,5 @@
 
 if (!empty($_GET['sent'])) {
-		echo '<p class="message">'.__('All pings sent.').'</p>';
+	dcPage::message(__('All pings sent.'));
 }
 
Index: admin/update.php
===================================================================
--- admin/update.php	(revision 769)
+++ admin/update.php	(revision 941)
@@ -42,4 +42,9 @@
 $step = in_array($step,array('check','download','backup','unzip')) ? $step : '';
 
+$default_tab = !empty($_GET['tab']) ? html::escapeHTML($_GET['tab']) : 'update';
+if (!empty($_POST['backup_file'])) {
+	$default_tab = 'files';
+}
+
 $archives = array();
 foreach (files::scanDir(DC_BACKUP_PATH) as $v) {
@@ -48,4 +53,9 @@
 	}
 }
+if (!empty($archives)) {
+	$archives = array_reverse($archives);
+} else {
+	$default_tab = 'update';
+}
 
 # Revert or delete backup file
@@ -61,5 +71,5 @@
 				throw new Exception(sprintf(__('Unable to delete file %s'),html::escapeHTML($b_file)));
 			}
-			http::redirect($p_url);
+			http::redirect($p_url.'?tab=files');
 		}
 		
@@ -69,5 +79,5 @@
 			$zip->unzipAll(DC_BACKUP_PATH.'/');
 			@unlink(DC_BACKUP_PATH.'/'.$b_file);
-			http::redirect($p_url);
+			http::redirect($p_url.'?tab=files');
 		}
 	}
@@ -157,5 +167,7 @@
 /* DISPLAY Main page
 -------------------------------------------------------- */
-dcPage::open(__('Dotclear update'));
+dcPage::open(__('Dotclear update'),
+	(!$step ? dcPage::jsPageTabs($default_tab) : '')
+);
 
 if (!$core->error->flag()) {
@@ -165,4 +177,5 @@
 if (!$step)
 {
+	echo '<div class="multi-part" id="update" title="'.__('Dotclear update').'">';
 	if (empty($new_v))
 	{
@@ -183,7 +196,10 @@
 		'</form>';
 	}
+	echo '</div>';
 	
 	if (!empty($archives))
 	{
+		echo '<div class="multi-part" id="files" title="'.__('Manage backup files').'">';
+
 		echo
 		'<h3>'.__('Update backup files').'</h3>'.
@@ -208,4 +224,6 @@
 		$core->formNonce().'</p>'.
 		'</form>';
+
+		echo '</div>';
 	}
 }
Index: admin/user.php
===================================================================
--- admin/user.php	(revision 860)
+++ admin/user.php	(revision 907)
@@ -178,9 +178,9 @@
 
 if (!empty($_GET['upd'])) {
-		echo '<p class="message">'.__('User has been successfully updated.').'</p>';
+	dcPage::message(__('User has been successfully updated.'));
 }
 
 if (!empty($_GET['add'])) {
-		echo '<p class="message">'.__('User has been successfully created.').'</p>';
+	dcPage::message(__('User has been successfully created.'));
 }
 
Index: admin/users.php
===================================================================
--- admin/users.php	(revision 860)
+++ admin/users.php	(revision 907)
@@ -99,8 +99,8 @@
 {
 	if (!empty($_GET['del'])) {
-		echo '<p class="message">'.__('User has been successfully removed.').'</p>';
+		dcPage::message(__('User has been successfully removed.'));
 	}
 	if (!empty($_GET['upd'])) {
-			echo '<p class="message">'.__('The permissions have been successfully updated.').'</p>';
+		dcPage::message(__('The permissions have been successfully updated.'));
 	}
 	
Index: inc/admin/lib.dc.page.php
===================================================================
--- inc/admin/lib.dc.page.php	(revision 812)
+++ inc/admin/lib.dc.page.php	(revision 973)
@@ -159,5 +159,5 @@
 		if ($core->error->flag()) {
 			echo
-			'<div class="error"><strong>'.__('Errors:').'</strong>'.
+			'<div class="error"><p><strong>'.(count($core->error->getErrors()) > 1 ? __('Errors:') : __('Error:')).'</p></strong>'.
 			$core->error->toHTML().
 			'</div>';
@@ -167,4 +167,6 @@
 	public static function close()
 	{
+		global $core;
+
 		$menu =& $GLOBALS['_menu'];
 		
@@ -179,9 +181,12 @@
 		}
 		
+		$text = sprintf(__('Thank you for using %s.'),'<a href="http://dotclear.org/">Dotclear '.DC_VERSION.'</a>');
+
+		# --BEHAVIOR-- adminPageFooter
+		$textAlt = $core->callBehavior('adminPageFooter',$core,$text);
+
 		echo
 		'</div>'."\n".		// End of #main-menu
-		'<div id="footer"><p>'.
-		sprintf(__('Thank you for using %s.'),'<a href="http://dotclear.org/">Dotclear '.DC_VERSION.'</a>').
-		'</p></div>'."\n".
+		'<div id="footer"><p>'.($textAlt != '' ? $textAlt : $text).'</p></div>'."\n".
 		"</div>\n";		// End of #wrapper
 		
@@ -254,4 +259,20 @@
 		"</div>\n".		// End of #wrapper
 		'</body></html>';
+	}
+
+	public static function message($msg,$timestamp=true,$div=false,$echo=true)
+	{
+		global $core;
+		
+		$res = '';
+		if ($msg != '') {
+			$res = ($div ? '<div class="message">' : '').'<p'.($div ? '' : ' class="message"').'>'.
+				($timestamp ? dt::str(__('%H:%M:%S:'),null,$core->auth->getInfo('user_tz')).' ' : '').$msg.
+				'</p>'.($div ? '</div>' : '');
+			if ($echo) {
+				echo $res;
+			}
+		}
+		return $res;
 	}
 	
@@ -370,4 +391,5 @@
 		self::jsLoad('js/jquery/jquery.biscuit.js').
 		self::jsLoad('js/jquery/jquery.bgFade.js').
+		self::jsLoad('js/jquery/jquery.constantfooter.js').
 		self::jsLoad('js/common.js').
 		self::jsLoad('js/prelude.js').
Index: inc/admin/prepend.php
===================================================================
--- inc/admin/prepend.php	(revision 859)
+++ inc/admin/prepend.php	(revision 962)
@@ -55,4 +55,5 @@
 	}
 	l10n::set(dirname(__FILE__).'/../../locales/'.$_lang.'/main');
+	l10n::set(dirname(__FILE__).'/../../locales/'.$_lang.'/public');
 	l10n::set(dirname(__FILE__).'/../../locales/'.$_lang.'/plugins');
 }
Index: inc/core/class.dc.blog.php
===================================================================
--- inc/core/class.dc.blog.php	(revision 836)
+++ inc/core/class.dc.blog.php	(revision 970)
@@ -1598,4 +1598,19 @@
 			$this->core->initWikiPost();
 			$this->core->wiki2xhtml->setOpt('note_prefix','pnote-'.$post_id);
+			switch ($this->settings->system->note_title_tag) {
+				case 1:
+					$tag = 'h3';
+					break;
+				case 2:
+					$tag = 'p';
+					break;
+				default:
+					$tag = 'h4';
+					break;
+			}
+			$this->core->wiki2xhtml->setOpt('note_str','<div class="footnotes"><'.$tag.' class="footnotes-title">'.
+				__('Notes').'</'.$tag.'>%s</div>');
+			$this->core->wiki2xhtml->setOpt('note_str_single','<div class="footnotes"><'.$tag.' class="footnotes-title">'.
+				__('Note').'</'.$tag.'>%s</div>');
 			if (strpos($lang,'fr') === 0) {
 				$this->core->wiki2xhtml->setOpt('active_fr_syntax',1);
Index: inc/core/class.dc.media.php
===================================================================
--- inc/core/class.dc.media.php	(revision 771)
+++ inc/core/class.dc.media.php	(revision 909)
@@ -912,6 +912,7 @@
 					($suffix == 'sq' || $w > $s[0] || $h > $s[0]))
 				{
+					$rate = ($s[0] < 100 ? 95 : ($s[0] < 600 ? 90 : 85));
 					$img->resize($s[0],$s[0],$s[1]);
-					$img->output('jpeg',$thumb_file,80);
+					$img->output('jpeg',$thumb_file,$rate);
 				}
 			}
Index: inc/core/class.dc.namespace.php
===================================================================
--- inc/core/class.dc.namespace.php	(revision 270)
+++ inc/core/class.dc.namespace.php	(revision 934)
@@ -259,7 +259,37 @@
 		}
 	}
-	
-	/**
-	Removes an existing setting. Namespace 
+
+	/**
+	Rename an existing setting in a Namespace
+
+	@param 	$oldId 	<b>string</b> 	Current setting name
+	@param 	$newId 	<b>string</b> 	New setting name
+	@return 	<b>boolean</b>
+	*/
+	public function rename($oldId,$newId)
+	{
+		if (!$this->ns) {
+			throw new Exception(__('No namespace specified'));
+		}
+		
+		if (!array_key_exists($oldId,$this->settings) || array_key_exists($newId,$this->settings)) {
+			return false;
+		}
+
+		// Rename the setting in the settings array
+		$this->settings[$newId] = $this->settings[$oldId];
+		unset($this->settings[$oldId]);
+
+		// Rename the setting in the database
+		$strReq = 'UPDATE '.$this->table.
+			" SET setting_id = '".$this->con->escape($newId)."' ".
+			" WHERE setting_ns = '".$this->con->escape($this->ns)."' ".
+			" AND setting_id = '".$this->con->escape($oldId)."' ";
+		$this->con->execute($strReq);
+		return true;
+	}
+
+	/**
+	Removes an existing setting in a Namespace 
 	
 	@param	id		<b>string</b>		Setting ID
@@ -286,4 +316,37 @@
 	
 	/**
+	Removes all existing settings in a Namespace 
+	
+	@param	force_global	<b>boolean</b>	Force global pref drop
+	*/
+	public function dropAll($force_global=false)
+	{
+		if (!$this->ns) {
+			throw new Exception(__('No namespace specified'));
+		}
+		
+		$strReq =	'DELETE FROM '.$this->table.' ';
+		
+		if (($force_global) || ($this->blog_id === null)) {
+			$strReq .= 'WHERE blog_id IS NULL ';
+			$global = true;
+		} else {
+			$strReq .= "WHERE blog_id = '".$this->con->escape($this->blog_id)."' ";
+			$global = false;
+		}
+		
+		$strReq .= "AND setting_ns = '".$this->con->escape($this->ns)."' ";
+		
+		$this->con->execute($strReq);
+		
+		$array = $global ? 'global' : 'local';
+		unset($this->{$array.'_settings'});
+		$this->{$array.'_settings'} = array();
+		
+		$array = $global ? 'local' : 'global';
+		$this->settings = $this->{$array.'_settings'};
+	}
+	
+	/**
 	Returns $settings property content.
 	
Index: inc/core/class.dc.prefs.php
===================================================================
--- inc/core/class.dc.prefs.php	(revision 147)
+++ inc/core/class.dc.prefs.php	(revision 934)
@@ -98,4 +98,51 @@
 	
 	/**
+	Rename a workspace.
+
+	@param	oldWs 	<b>string</b> 	Old workspace name
+	@param	newws 	<b>string</b> 	New workspace name
+	@return 	<b>boolean</b>
+	*/
+	public function renWorkspace($oldNs,$newNs)
+	{
+		if (!array_key_exists($oldWs, $this->workspaces) || array_key_exists($newWs, $this->workspaces)) {
+			return false;
+		}
+
+		// Rename the workspace in the workspace array
+		$this->workspaces[$newWs] = $this->workspaces[$oldWs];
+		unset($this->workspaces[$oldWs]);
+
+		// Rename the workspace in the database
+		$strReq = 'UPDATE '.$this->table.
+			" SET pref_ws = '".$this->con->escape($newWs)."' ".
+			" WHERE pref_ws = '".$this->con->escape($oldWs)."' ";
+		$this->con->execute($strReq);
+		return true;
+	}
+
+	/**
+	Delete a whole workspace with all preferences pertaining to it.
+
+	@param 	ws 	<b>string</b> 	Workspace name
+	@return 	<b>boolean</b>
+	*/
+	public function delWorkspace($ws)
+	{
+		if (!array_key_exists($ws, $this->workspaces)) {
+			return false;
+		}
+
+		// Remove the workspace from the workspace array
+		unset($this->workspaces[$ws]);
+
+		// Delete all preferences from the workspace in the database
+		$strReq = 'DELETE FROM '.$this->table.
+			" WHERE pref_ws = '".$this->con->escape($ws)."' ";
+		$this->con->execute($strReq);
+		return true;
+	}
+	
+	/**
 	Returns full workspace with all prefs pertaining to it.
 	
Index: inc/core/class.dc.rs.extensions.php
===================================================================
--- inc/core/class.dc.rs.extensions.php	(revision 776)
+++ inc/core/class.dc.rs.extensions.php	(revision 912)
@@ -165,4 +165,14 @@
 	{
 		return $rs->nb_trackback > 0;
+	}
+
+	/**
+	Returns whether post has been updated since publication.
+
+	@return <b>boolean</b>
+	*/
+	public static function isRepublished($rs)
+	{
+		return ($rs->getTS('upddt') + dt::getTimeOffset($rs->post_tz)) > $rs->getTS();
 	}
 	
Index: inc/core/class.dc.settings.php
===================================================================
--- inc/core/class.dc.settings.php	(revision 301)
+++ inc/core/class.dc.settings.php	(revision 934)
@@ -92,4 +92,51 @@
 		return $this->namespaces[$ns];
 	}
+
+	/**
+	Rename a namespace.
+
+	@param	oldNs 	<b>string</b> 	Old namespace name
+	@param	newNs 	<b>string</b> 	New namespace name
+	@return 	<b>boolean</b>
+	*/
+	public function renNamespace($oldNs,$newNs)
+	{
+		if (!array_key_exists($oldNs, $this->namespaces) || array_key_exists($newNs, $this->namespaces)) {
+			return false;
+		}
+
+		// Rename the namespace in the namespace array
+		$this->namespaces[$newNs] = $this->namespaces[$oldNs];
+		unset($this->namespaces[$oldNs]);
+
+		// Rename the namespace in the database
+		$strReq = 'UPDATE '.$this->table.
+			" SET setting_ns = '".$this->con->escape($newNs)."' ".
+			" WHERE setting_ns = '".$this->con->escape($oldNs)."' ";
+		$this->con->execute($strReq);
+		return true;
+	}
+
+	/**
+	Delete a whole namespace with all settings pertaining to it.
+
+	@param 	ns 	<b>string</b> 	Namespace name
+	@return 	<b>boolean</b>
+	*/
+	public function delNamespace($ns)
+	{
+		if (!array_key_exists($ns, $this->namespaces)) {
+			return false;
+		}
+
+		// Remove the namespace from the namespace array
+		unset($this->namespaces[$ns]);
+
+		// Delete all settings from the namespace in the database
+		$strReq = 'DELETE FROM '.$this->table.
+			" WHERE setting_ns = '".$this->con->escape($ns)."' ";
+		$this->con->execute($strReq);
+		return true;
+	}
 	
 	/**
Index: inc/core/class.dc.workspace.php
===================================================================
--- inc/core/class.dc.workspace.php	(revision 147)
+++ inc/core/class.dc.workspace.php	(revision 934)
@@ -263,4 +263,34 @@
 		}
 	}
+
+	/**
+	Rename an existing pref in a Workspace
+
+	@param 	$oldId 	<b>string</b> 	Current pref name
+	@param 	$newId 	<b>string</b> 	New pref name
+	@return 	<b>boolean</b>
+	*/
+	public function rename($oldId,$newId)
+	{
+		if (!$this->ws) {
+			throw new Exception(__('No workspace specified'));
+		}
+		
+		if (!array_key_exists($oldId,$this->prefs) || array_key_exists($newId,$this->prefs)) {
+			return false;
+		}
+
+		// Rename the pref in the prefs array
+		$this->prefs[$newId] = $this->prefs[$oldId];
+		unset($this->prefs[$oldId]);
+
+		// Rename the pref in the database
+		$strReq = 'UPDATE '.$this->table.
+			" SET pref_id = '".$this->con->escape($newId)."' ".
+			" WHERE pref_ws = '".$this->con->escape($this->ws)."' ".
+			" AND pref_id = '".$this->con->escape($oldId)."' ";
+		$this->con->execute($strReq);
+		return true;
+	}
 	
 	/**
Index: inc/core_error.php
===================================================================
--- inc/core_error.php	(revision 270)
+++ inc/core_error.php	(revision 921)
@@ -12,4 +12,5 @@
 
 header('Content-Type: text/html; charset=utf-8');
+header("HTTP/1.0 ".$code." ".$summary);
 ?>
 <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
Index: inc/dbschema/db-schema.php
===================================================================
--- inc/dbschema/db-schema.php	(revision 407)
+++ inc/dbschema/db-schema.php	(revision 919)
@@ -164,5 +164,5 @@
 	->log_dt		('timestamp',	0,	false,	'now()')
 	->log_ip		('varchar',	39,	false)
-	->log_msg		('varchar',	255,	false)
+	->log_msg		('text',	0,	true,	null)
 	
 	->primary('pk_log','log_id')
Index: inc/public/class.dc.template.php
===================================================================
--- inc/public/class.dc.template.php	(revision 863)
+++ inc/public/class.dc.template.php	(revision 980)
@@ -85,4 +85,5 @@
 		$this->addValue('CategoryDescription',array($this,'CategoryDescription'));
 		$this->addValue('CategoryTitle',array($this,'CategoryTitle'));
+		$this->addValue('CategoryEntriesCount',array($this,'CategoryEntriesCount'));
 		
 		# Comments
@@ -205,4 +206,7 @@
 		$this->addValue('SysSearchString',array($this,'SysSearchString'));
 		$this->addValue('SysSelfURI',array($this,'SysSelfURI'));
+
+		# Generic
+		$this->addValue('else',array($this,'GenericElse'));
 	}
 	
@@ -388,5 +392,5 @@
 		$p[2] = '0';	# cut_string
 		$p[3] = '0';	# lower_case
-		$p[4] = '0';	# upper_case
+		$p[4] = '0';	# upper_case or capitalize
 		
 		$p[0] = (integer) (!empty($attr['encode_xml']) || !empty($attr['encode_html']));
@@ -399,4 +403,5 @@
 		$p[3] = (integer) !empty($attr['lower_case']);
 		$p[4] = (integer) !empty($attr['upper_case']);
+		$p[4] = (!empty($attr['capitalize']) ? 2 : $p[4]);
 		
 		return "context::global_filter(%s,".implode(",",$p).",'".addslashes($this->current_tag)."')";
@@ -487,5 +492,5 @@
 	}
 	
-	public function getAge($attr)
+	public static function getAge($attr)
 	{
 		if (isset($attr['age']) && preg_match('/^(\-[0-9]+|last).*$/i',$attr['age'])) {
@@ -1096,4 +1101,13 @@
 		$f = $this->getFilters($attr);
 		return '<?php echo '.sprintf($f,'$_ctx->categories->cat_title').'; ?>';
+	}
+
+	/*dtd
+	<!ELEMENT tpl:CategoryEntriesCount - O -- Category number of entries -->
+	*/
+	public function CategoryEntriesCount($attr)
+	{
+		$f = $this->getFilters($attr);
+		return '<?php echo '.sprintf($f,'$_ctx->categories->nb_post').'; ?>';
 	}
 	
@@ -1269,4 +1283,5 @@
 	show_comments	(0|1)	#IMPLIED	-- there are comments for this post (value : 1) or not (value : 0)
 	show_pings	(0|1)	#IMPLIED	-- there are trackbacks for this post (value : 1) or not (value : 0)
+	republished	(0|1)	#IMPLIED	-- post has been updated since publication (value : 1) or not (value : 0)
 	operator	(and|or)	#IMPLIED	-- combination of conditions, if more than 1 specifiec (default: and)
 	url		CDATA	#IMPLIED	-- post has given url
@@ -1368,4 +1383,9 @@
 		}
 		
+		if (isset($attr['republished'])) {
+			$sign = (boolean) $attr['republished'] ? '' : '!';
+			$if[] = $sign.'(boolean)$_ctx->posts->isRepublished()';
+		}
+		
 		$this->core->callBehavior('tplIfConditions','EntryIf',$attr,$content,$if);
 		
@@ -1601,4 +1621,7 @@
 	class		CDATA		#IMPLIED	-- Class to add on image tag
 	with_category	(1|0)		#IMPLIED	-- Search in entry category description if present (default 0)
+	no_tag	(1|0)	#IMPLIED	-- Return image URL without HTML tag (default 0)
+	content_only	(1|0)		#IMPLIED	-- Search in content entry only, not in excerpt (default 0)
+	cat_only	(1|0)		#IMPLIED	-- Search in category description only (default 0)
 	>
 	*/
@@ -1607,7 +1630,11 @@
 		$size = !empty($attr['size']) ? $attr['size'] : '';
 		$class = !empty($attr['class']) ? $attr['class'] : '';
-		$with_category = !empty($attr['with_category']) ? 'true' : 'false';
-		
-		return "<?php echo context::EntryFirstImageHelper('".addslashes($size)."',".$with_category.",'".addslashes($class)."'); ?>";
+		$with_category = !empty($attr['with_category']) ? 1 : 0;
+		$no_tag = !empty($attr['no_tag']) ? 1 : 0;
+		$content_only = !empty($attr['content_only']) ? 1 : 0;
+		$cat_only = !empty($attr['cat_only']) ? 1 : 0;
+		
+		return "<?php echo context::EntryFirstImageHelper('".addslashes($size)."',".$with_category.",'".addslashes($class)."',".
+			$no_tag.",".$content_only.",".$cat_only."); ?>";
 	}
 	
@@ -2948,5 +2975,5 @@
 	
 	/*dtd
-	<!ELEMENT tpl:SysIfFormError - O -- Form error -->
+	<!ELEMENT tpl:SysFormError - O -- Form error -->
 	*/
 	public function SysFormError($attr)
@@ -2974,4 +3001,12 @@
 		$f = $this->getFilters($attr);
 		return '<?php echo '.sprintf($f,'http::getSelfURI()').'; ?>';
+	}
+
+	/*dtd
+	<!ELEMENT tpl:else - O -- else: statement -->
+	*/
+	public function GenericElse($attr)
+	{
+		return '<?php else: ?>';
 	}
 }
Index: inc/public/lib.tpl.context.php
===================================================================
--- inc/public/lib.tpl.context.php	(revision 839)
+++ inc/public/lib.tpl.context.php	(revision 975)
@@ -127,5 +127,9 @@
 			$str = self::lower_case($str);
 		} elseif ($upper_case) {
-			$str = self::upper_case($str);
+			if ($upper_case == 2) {
+				$str = self::capitalize($str);
+			} else {
+				$str = self::upper_case($str);
+			}
 		}
 		
@@ -160,4 +164,12 @@
 	{
 		return mb_strtoupper($str);
+	}
+
+	public static function capitalize($str)
+	{
+		if ($str != '') {
+		   $str[0] = mb_strtoupper($str[0]);
+		}
+		return $str;
 	}
 	
@@ -336,10 +348,69 @@
 			return $str;
 		}
-		
-		return preg_replace(array_keys($GLOBALS['__smilies']),array_values($GLOBALS['__smilies']),$str);
-	}
-	
+
+		# Process part adapted from SmartyPants engine (J. Gruber et al.) :
+
+		$tokens = self::tokenizeHTML($str);
+		$result = '';
+		$in_pre = 0;  # Keep track of when we're inside <pre> or <code> tags.
+
+		foreach ($tokens as $cur_token) {
+			if ($cur_token[0] == "tag") {
+				# Don't mess with quotes inside tags.
+				$result .= $cur_token[1];
+				if (preg_match('@<(/?)(?:pre|code|kbd|script|math)[\s>]@', $cur_token[1], $matches)) {
+					$in_pre = isset($matches[1]) && $matches[1] == '/' ? 0 : 1;
+				}
+			} else {
+				$t = $cur_token[1];
+				if (!$in_pre) {
+					$t = preg_replace(array_keys($GLOBALS['__smilies']),array_values($GLOBALS['__smilies']),$t);
+				}
+				$result .= $t;
+			}
+		}
+
+		return $result;
+	}
+
+	private static function tokenizeHTML($str)
+	{
+		# Function from SmartyPants engine (J. Gruber et al.)
+		#
+		#   Parameter:  String containing HTML markup.
+		#   Returns:    An array of the tokens comprising the input
+		#               string. Each token is either a tag (possibly with nested,
+		#               tags contained therein, such as <a href="<MTFoo>">, or a
+		#               run of text between tags. Each element of the array is a
+		#               two-element array; the first is either 'tag' or 'text';
+		#               the second is the actual value.
+		#
+		#
+		#   Regular expression derived from the _tokenize() subroutine in 
+		#   Brad Choate's MTRegex plugin.
+		#   <http://www.bradchoate.com/past/mtregex.php>
+		#
+		$index = 0;
+		$tokens = array();
+
+		$match = '(?s:<!(?:--.*?--\s*)+>)|'.	# comment
+				 '(?s:<\?.*?\?>)|'.				# processing instruction
+												# regular tags
+				 '(?:<[/!$]?[-a-zA-Z0-9:]+\b(?>[^"\'>]+|"[^"]*"|\'[^\']*\')*>)'; 
+
+		$parts = preg_split("{($match)}", $str, -1, PREG_SPLIT_DELIM_CAPTURE);
+
+		foreach ($parts as $part) {
+			if (++$index % 2 && $part != '') 
+				$tokens[] = array('text', $part);
+			else
+				$tokens[] = array('tag', $part);
+		}
+		return $tokens;
+	}
+
+
 	# First post image helpers
-	public static function EntryFirstImageHelper($size,$with_category,$class="")
+	public static function EntryFirstImageHelper($size,$with_category,$class="",$no_tag=false,$content_only=false,$cat_only=false)
 	{
 		global $core, $_ctx;
@@ -355,5 +426,5 @@
 		
 		$pattern = '(?:'.preg_quote($p_site,'/').')?'.preg_quote($p_url,'/');
-		$pattern = sprintf('/<img.+?src="%s(.*?\.(?:jpg|jpeg|gif|png))"[^>]+/msu',$pattern);
+		$pattern = sprintf('/<img.+?src="%s(.*?\.(?:jpg|jpeg|gif|png))"[^>]+/msui',$pattern);
 		
 		$src = '';
@@ -361,12 +432,13 @@
 		
 		# We first look in post content
-		if ($_ctx->posts)
-		{
-			$subject = $_ctx->posts->post_excerpt_xhtml.$_ctx->posts->post_content_xhtml;
+		if (!$cat_only && $_ctx->posts)
+		{
+			$subject = ($content_only ? '' : $_ctx->posts->post_excerpt_xhtml).$_ctx->posts->post_content_xhtml;
 			if (preg_match_all($pattern,$subject,$m) > 0)
 			{
 				foreach ($m[1] as $i => $img) {
 					if (($src = self::ContentFirstImageLookup($p_root,$img,$size)) !== false) {
-						$src = $p_url.(dirname($img) != '/' ? dirname($img) : '').'/'.$src;
+						$dirname = str_replace('\\', '/', dirname($img)); 
+						$src = $p_url.($dirname != '/' ? $dirname : '').'/'.$src;
 						if (preg_match('/alt="([^"]+)"/',$m[0][$i],$malt)) {
 							$alt = $malt[1];
@@ -385,5 +457,6 @@
 				foreach ($m[1] as $i => $img) {
 					if (($src = self::ContentFirstImageLookup($p_root,$img,$size)) !== false) {
-						$src = $p_url.(dirname($img) != '/' ? dirname($img) : '').'/'.$src;
+						$dirname = str_replace('\\', '/', dirname($img)); 
+						$src = $p_url.($dirname != '/' ? $dirname : '').'/'.$src;
 						if (preg_match('/alt="([^"]+)"/',$m[0][$i],$malt)) {
 							$alt = $malt[1];
@@ -396,5 +469,9 @@
 		
 		if ($src) {
-			return '<img alt="'.$alt.'" src="'.$src.'" class="'.$class.'" />';
+			if ($no_tag) {
+				return $src;
+			} else {
+				return '<img alt="'.$alt.'" src="'.$src.'" class="'.$class.'" />';
+			}
 		}
 	}
@@ -432,4 +509,12 @@
 			} elseif (file_exists($f.'.gif')) {
 				$res = $base.'.gif';
+			} elseif (file_exists($f.'.JPG')) {
+				$res = $base.'.JPG';
+			} elseif (file_exists($f.'.JPEG')) {
+				$res = $base.'.JPEG';
+			} elseif (file_exists($f.'.PNG')) {
+				$res = $base.'.PNG';
+			} elseif (file_exists($f.'.GIF')) {
+				$res = $base.'.GIF';
 			}
 		}
